SystemOrganization addCategory: #ConfigurationOfRoelTyper!

Object subclass: #ConfigurationOfRoelTyper
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfRoelTyper'!

!ConfigurationOfRoelTyper commentStamp: '<historical>' prior: 0!
(ConfigurationOfRoelTyper project version: #stable) load!

!ConfigurationOfRoelTyper class methodsFor: 'private' stamp: 'StephaneDucasse 2/17/2013 18:28'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfRoelTyper class methodsFor: 'private' stamp: 'StephaneDucasse 2/17/2013 18:28'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.21"
			self bootstrapPackage: 'Gofer-Core-lr.115' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load 'default' group of Metacello"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #load ]! !

!ConfigurationOfRoelTyper class methodsFor: 'metacello tool support' stamp: 'StephaneDucasse 2/17/2013 18:28'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfRoelTyper class methodsFor: 'metacello tool support' stamp: 'StephaneDucasse 2/17/2013 18:28'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfRoelTyper class methodsFor: 'loading' stamp: 'StephaneDucasse 2/17/2013 18:28'!
load
	"self load"

	^self project latestVersion load! !

!ConfigurationOfRoelTyper class methodsFor: 'loading' stamp: 'StephaneDucasse 2/17/2013 18:28'!
loadDefault
	"self loadDefault"

	^ self loadMostRecentCoreWithTests! !

!ConfigurationOfRoelTyper class methodsFor: 'loading' stamp: 'StephaneDucasse 2/17/2013 18:28'!
loadMostRecentCoreWithTests
	^self project lastVersion load: #('Core' 'Tests')! !

!ConfigurationOfRoelTyper class methodsFor: 'metacello tool support' stamp: 'StephaneDucasse 2/17/2013 18:28'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfRoelTyper class methodsFor: 'accessing' stamp: 'StephaneDucasse 2/17/2013 18:28'!
project

	^self new project! !

!ConfigurationOfRoelTyper class methodsFor: 'unloading Metacello' stamp: 'StephaneDucasse 2/17/2013 18:28'!
unloadMetacello

	Smalltalk at: #ConfigurationOfMetacello ifPresent: [:cls | cls unloadMetacello ]! !

!ConfigurationOfRoelTyper methodsFor: 'baselines' stamp: 'StephaneDucasse 2/17/2013 18:31'!
baseline100: spec 
	<version: '1.0-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://smalltalkhub.com/mc/RMoD/RoelTyper/main'.	
		spec description: 'Imported from SqueakSource'.
		spec package: 'RoelTyper'.
			
		spec
			group: 'default' with: #('Core');
			group: 'Core' with: #('RoelTyper')
			
			";
			group: 'Tests' with: #('Collections-Tests-OrderPreservingDictionary')."
			
			 ].! !

!ConfigurationOfRoelTyper methodsFor: 'symbolic versions' stamp: 'StephaneDucasse 2/17/2013 18:28'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.0'
! !

!ConfigurationOfRoelTyper methodsFor: 'accessing' stamp: 'StephaneDucasse 2/17/2013 18:28'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfRoelTyper methodsFor: 'symbolic versions' stamp: 'StephaneDucasse 2/17/2013 18:28'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0'.
	! !

!ConfigurationOfRoelTyper methodsFor: 'versions' stamp: 'StephaneDucasse 2/17/2013 18:34'!
version100: spec 
	<version: '1.0' imports: #('1.0-baseline') >
	
	spec for: #common do: [
		spec blessing: #release.
		spec description: 'Migration to SmalltalkHub'.
		
		spec package: 'RoelTyper' with: 'Collections-OrderPreservingDictionary-JAA.7'.
		
		]
	

! !
